'   Prozeduren: Cvt_numerisch_to_DBF und Cvt_numerisch_from_DBF

' Version 3.0  26.3.2002.      Die Prozedur kann frei benutzt werden, fr
'                              Schden kann keine Haftung bernommen werden.
' Autor: Gerhard Putschalka    
'                       email: g.putschalka@web.de
'                    homepage: http://members.telering.at/g.putschalka/index.html

' Beschreibung der Prozeduren in CvDbNum.prf

Proc Cvt_numerisch_to_DBF
   Parameters Zx$,Lo%,Do%
   Declare Ganz$,Dezi$,Ix%,Iy%,Rc%,Ret$,Sign$,Zw$
   Let Zx$ = @Trim$(Zx$)
   Let Ganz$ = ""
   Let Dezi$ = ""
   Let Sign$ = ""
   Let Rc%   = 0
   Let Zx$ = @Trim$(@Translate$(Zx$,".","")) ' entferne Punkte und ussere Leerstellen   
   Let Zw$ = @Translate$(Zx$,",","") ' entferne testhalber Komma(s)
   Let Ix% = (@Len(Zx$) - @Len(Zw$))
   If (Ix% > 1)   ' mehr als 1 Komma eingegeben - beende mit Return = 4
      Let Ret$ = "4;0"
      Return Ret$
   EndIf
   ' hier ist der eingegebene Wert ohne ussere Leerstellen, ohne Punkte und hat max.
   ' ein Komma enthalten
   Let Ganz$ = @Substr$(Zx$,1,",") ' lse ganze Stellen
   Let Dezi$ = @Substr$(Zx$,2,",") ' lse Dezimalstellen (wenn vorhanden)
   ' nun drfen in Ganz$ und Dezi$ nur Ziffern sein (1. Stelle in Ganz$ darf auch "-" sein
   Let Ix% = @Len(Ganz$)
   Let Iy% = 1
   If @Equ$(@Left$(Ganz$,1),"-")
      Let Iy% = 2 ' Minus, prfe ab 2. Stelle
      Case (@Len(Ganz$) = 1) : Let Ganz$ = "-0"
   Else
      Case (@Len(Ganz$) = 0) : Let Ganz$ = "0"
   EndIf

   Case @Equ$(@Left$(Ganz$,1),"-") : Let Iy% = 2 ' Minus, prfe ab 2. Stelle
   WhileNot (Iy% > Ix%)
      Case (@Lt$(@Mid$(Ganz$,Iy%,1),"0") or @Gt$(@Mid$(Ganz$,Iy%,1),"9")) : Let Rc% = 9
      Inc Iy%
   EndWhile
      
   Let Ix% = @Len(Dezi$)
   Let Iy% = 1
   WhileNot (Iy% > Ix%)
      Case (@Lt$(@Mid$(Dezi$,Iy%,1),"0") or @Gt$(@Mid$(Dezi$,Iy%,1),"9")) : Let Rc% = 9
      Inc Iy%
   EndWhile   

   If (Rc% = 9)    ' ungltige Zeichen entdeckt - beende
      Let Ret$ = "9;0"
      Return Ret$
   EndIf   

   ' prfe Ganze Stellen auf zu viele oder zu wenige Zeichen
   Let Ix% = Lo%
   Case (Do% > 0) : Let Ix% = (Lo% - Do% - 1) ' Ix% = Soll: Anzahl ganze Stellen
   If (@Len(Ganz$) > Ix%)
      Let Rc% = 2                    ' zu viele Stellen eingegeben
      Let Ganz$ = @Right$(Ganz$,Ix%)
   ElseIf (@Len(Ganz$) < Ix%)        ' zuwenige Stellen, flle mit fhr. Leerstellen auf
      Let Ix% = (Ix% - @Len(Ganz$))
      Let Ganz$ = Space$(Ix%);Ganz$
   EndIf

   ' prfe Dezimalstellen auf zu viele oder zu wenige Zeichen
   Let Ix% = Do%
   If (@Len(Dezi$) > Do%)
      Let Rc% = (Rc% + 1)            ' zu viele Stellen eingegeben
      Let Dezi$ = @Left$(Dezi$,Do%)  ' schneide rechts ab
   ElseIf (@Len(Dezi$) < Do%)        ' zuwenige Stellen, flle mit endenden Nullen auf
      Let Ix% = (Do% - @Len(Dezi$))
      Let Dezi$ = Dezi$;@MkStr$("0",Ix%)
   EndIf   

   Case (@Len(Dezi$) > 0) : Let Dezi$ = ".";Dezi$
   Let Ret$ = @Str$(Rc%);";";Ganz$;Dezi$
   Return Ret$
EndProc
'___________________________________________________________________________________
Proc Cvt_numerisch_from_DBF
   Parameters Zw$,Sep$
   Declare Ga$,De$,Sg$,Lg%,Ga&
   Zw$ = @Trim$(Zw$)
   Ga$ = @Substr$(Zw$,1,".")  ' extrahiere ganze Stellen
   De$ = @Substr$(Zw$,2,".")  ' extrahiere Dezimalstellen
   Lg% = @Len(Ga$)
   If @Equ$(Sep$,".")         ' trifft zu, wenn Tausenderpunkte einzufgen sind
      Ga& = @Int(Ga$)
      Ga$ = @Format$("###,###,###,###,##0",Ga&)
   EndIf
   Ga$ = "0;";Ga$
   If (@Len(De$) > 0)
      Zw$ = Ga$;",";De$
   Else
      Zw$ = Ga$
   EndIf
   Return Zw$
EndProc
